char GENERIC[] = "\
#Copyright (c) 1995 University College London\n\
#see ui_fns.c for information on usage and redistribution of this file\n\
#and for a DISCLAIMER OF ALL WARRANTIES.\n\
\n\
proc lognewwindow {w} {\n\
}\n\
\n\
set tixBal(active) 1\n\
set tixBal(popped) 0\n\
\n\
proc tixEnableBalloon {} {\n\
    global tixBal\n\
    set tixBal(active) 0\n\
}\n\
\n\
proc tixDisableBalloon {} {\n\
    global tixBal\n\
    set tixBal(active) 0\n\
}\n\
proc tixBalloonAuto {} {\n\
    global initWait\n\
    set initWait 400\n\
}\n\
proc tixBalloonManual {} {\n\
    global initWait\n\
    global tixBal\n\
    if {$tixBal(popped) == 1} {\n\
      tixBalPopdown\n\
    }\n\
    set initWait -1\n\
}\n\
proc tixAddBalloon {w class msg {initWait 500}} { \n\
    global tixBal\n\
    if {$class == \"Button\" } {\n\
      bind $w <Enter> \"+tkButtonEnter $w\"\n\
      bind $w <Leave> \"+tkButtonLeave $w\"\n\
      bind $w <ButtonPress> \"+tixBalEnd $w\"\n\
    } else {\n\
    if { $class == \"Entry\" } {\n\
      bind $w <ButtonPress> \"+tixBalEnd $w\"\n\
      bind $w <ButtonPress> \"+focus $w\"\n\
    }\n\
    }\n\
#    bind $w <2> \"+tixBalPopup $w\"\n\
    bind $w <Enter>  +[bind $class <Enter>]\n\
    bind $w <Enter>  \"+tixBalStart $w\"\n\
    bind $w <Leave>  +[bind $class <Leave>]\n\
    bind $w <Leave>  \"+tixBalEnd $w\"\n\
    bind $w <Destroy>  +[bind $class <Destroy>]\n\
    bind $w <Destroy> \"+catch {unset tixBal($w)}\"\n\
\n\
    set tixBal($w) $msg\n\
}\n\
\n\
proc tixBalStart {w} {\n\
    global tixBal\n\
    global initWait\n\
    global last_widget\n\
    if {$initWait == -1} {\n\
      return\n\
    }\n\
    set last_widget $w\n\
    	after $initWait \"careful_popup $w\"\n\
}\n\
\n\
proc careful_popup {w} {\n\
    global last_widget\n\
    if {$w==$last_widget} {tixBalActivate $w}\n\
}\n\
\n\
proc tixBalEnd {w} {\n\
    global tixBal\n\
    global last_widget\n\
\n\
    if {$w==$last_widget} {set last_widget foo}\n\
    if {$tixBal(popped) == \"1\"} {\n\
        tixBalPopdown\n\
    } \n\
}\n\
\n\
proc tixBalMotion {w} {\n\
    global tixBal\n\
    global initWait\n\
\n\
    if {$initWait == -1} {\n\
      return\n\
    }\n\
    if {$tixBal(active) == \"1\" && $tixBal(popped) == 0} {\n\
	incr tixBal(count)\n\
        after $initWait tixBalActivate $w\n\
    }\n\
}\n\
\n\
proc tixBalActivate {w} {\n\
    global tixBal\n\
        tixBalPopup $w\n\
}\n\
\n\
proc tixBalPopup {widget} {\n\
    global tixBal\n\
\n\
    set w .tix_balloon\n\
\n\
    catch {\n\
        toplevel $w\n\
	set bg    [tixQueryAppResource balloonBg TixBalloonBg #ffff60]\n\
	set fg    [tixQueryAppResource balloonFg TixBalloonFg black]\n\
	set width [tixQueryAppResource tixBalloonWidth TixBalloonWidth 180]\n\
	wm overrideredirect $w 1\n\
	message $w.msg -bg $bg -fg $fg -width $width\n\
	pack $w.msg -expand yes -fill both\n\
    }\n\
\n\
    set x [expr [winfo rootx $widget]+[winfo width  $widget]-8]\n\
    set y [expr [winfo rooty $widget]+[winfo height $widget]-8]\n\
    $w.msg config -text $tixBal($widget)\n\
    wm geometry $w +$x+$y\n\
    wm deiconify $w\n\
    raise $w\n\
    set tixBal(popped) 1\n\
}\n\
    \n\
proc tixBalPopdown {} {\n\
    global tixBal\n\
    set w .tix_balloon\n\
\n\
    wm withdraw $w\n\
    set tixBal(popped) 0\n\
}\n\
\n\
proc tixQueryAppResource {name class default} {\n\
\n\
    set value [option get . $name Sdr]\n\
    if {$value == \"\"} {\n\
	return $default\n\
    } else {\n\
	return $value\n\
    }    \n\
}\n\
option add *balloonHelp 1\n\
\n\
if { [option get . balloonHelp Mtool] == 0 } {\n\
 tixBalloonManual\n\
  set balloonHelp 0\n\
} else {\n\
  tixBalloonAuto\n\
  set balloonHelp 1\n\
}\n\
\n\
proc set_balloon_help {mode} {\n\
 if {$mode==0} {\n\
     tixBalloonManual\n\
 } else {\n\
     tixBalloonAuto\n\
 }\n\
}\n\
\n\
proc fixint {i} {\n\
    if {$i == \"0\"} {return 0}\n\
    return [string trimleft $i 0]\n\
}\n\
proc posn_win {w} {\n\
    set geom [wm geometry .]\n\
    set xpos [expr [lindex [split $geom \"+x\"] 2] + 25]\n\
    set ypos [expr [lindex [split $geom \"+x\"] 3] + 25]\n\
    wm geometry $w \"+$xpos+$ypos\"\n\
}\n\
 \n\
proc posn_win_rel {w main} {\n\
    set geom [wm geometry $main]\n\
    set xpos [expr [lindex [split $geom \"+x\"] 2] + 25]\n\
    set ypos [expr [lindex [split $geom \"+x\"] 3] + 25]\n\
    wm geometry $w \"+$xpos+$ypos\"\n\
}\n\
set wmoffset(x) 0\n\
set wmoffset(y) 0\n\
set wmoffset(is) 0\n\
\n\
\n\
proc move_onscreen {w} {\n\
    global wmoffset\n\
    if {[winfo exists $w]==0} { return }\n\
    update\n\
    set wh [winfo reqheight $w]\n\
    set ww [winfo reqwidth $w]\n\
    set sh [winfo screenheight $w]\n\
    set sw [winfo screenwidth $w]\n\
    set x [winfo rootx $w]\n\
    set y [winfo rooty $w]\n\
    set flag 0\n\
    if {($x+$ww) > $sw} {\n\
	set x [expr $sw - $ww]\n\
	set flag 1\n\
    }\n\
    if {($y+$wh) > $sh} {\n\
	set y [expr $sh - $wh]\n\
	set flag 1\n\
    }\n\
    if {$flag == 1} {\n\
	wm geometry $w \"+[expr $x-$wmoffset(x)]+[expr $y-$wmoffset(y)]\"\n\
    }\n\
    if {($wmoffset(is)==0)&&($flag==1)} {\n\
	update\n\
	set nx [winfo rootx $w]\n\
	set ny [winfo rooty $w]\n\
	if {$nx!=$x} {\n\
	    set wmoffset(x) [expr $nx - $x]\n\
	}\n\
	if {$ny!=$y} {\n\
	    set wmoffset(y) [expr $ny - $y]\n\
	}\n\
	wm geometry $w \"+[expr $x-$wmoffset(x)]+[expr $y-$wmoffset(y)]\"\n\
	set wmoffset(is) 1\n\
    }\n\
}\n\
\n\
\n\
proc genericpopup {ename explan title} {\n\
    catch {destroy .epopup}\n\
    toplevel .epopup\n\
    wm title .epopup $title\n\
    posn_win .epopup\n\
    frame .epopup.f -relief groove -borderwidth 2\n\
    label .epopup.f.l -text $ename -font \"[option get . font Nt]\"\n\
    message .epopup.f.m -text $explan -font \"[option get . mediumFont Nt]\" -aspect 300\n\
    button .epopup.f.dismiss -text Dismiss -command \"destroy .epopup\"\n\
    pack .epopup.f -side top\n\
    pack .epopup.f.l -side top\n\
    pack .epopup.f.m -side top\n\
    pack .epopup.f.dismiss -side top -fill x -expand true\n\
}\n\
\n\
proc errorpopup {ename explan} {\n\
    bell\n\
    genericpopup $ename $explan \"Nt: Error!\"\n\
}\n\
proc msgpopup {ename explan} {\n\
    genericpopup $ename $explan \"Nt\"\n\
}\n\
proc timedmsgpopup {ename explan time} {\n\
    genericpopup $ename $explan \"Nt\"\n\
    after $time \"catch {destroy .epopup}\"\n\
}\n\
\n\
proc mtk_ImbPost {w {x {}} {y {}}} {\n\
    global tkPriv\n\
    if {([$w.workaround configure -state] == \"disabled\") || ($w == $tkPriv(postedMb))} {\n\
        return\n\
    }\n\
    set menu [$w.workaround configure -menu]\n\
    if {($menu == \"\") || ([$menu index last] == \"none\")} {\n\
        return\n\
    }\n\
    if ![string match $w.* $menu] {\n\
        error \"can't post $menu:  it isn't a descendant of $w (this is a new re\n\
    }\n\
    set cur $tkPriv(postedMb)\n\
    if {$cur != \"\"} {\n\
        tkMenuUnpost {}\n\
    }\n\
#    set tkPriv(cursor) [$w.workaround configure -cursor]\n\
    set tkPriv(relief) [$w.workaround configure -relief]\n\
 #   $w configure -cursor arrow\n\
    $w configure -relief raised\n\
    set tkPriv(postedMb) $w\n\
    set tkPriv(focus) [focus]\n\
    $menu activate none\n\
 \n\
    # If this looks like an option menubutton then post the menu so\n\
    # that the current entry is on top of the mouse.  Otherwise post\n\
    # the menu just below the menubutton, as for a pull-down.\n\
 \n\
#    if {([$w cget -indicatoron] == 1) && ([$w cget -textvariable] != \"\")} {\n\
#        if {$y == \"\"} {\n\
#            set x [expr [winfo rootx $w] + [winfo width $w]/2]\n\
#            set y [expr [winfo rooty $w] + [winfo height $w]/2]\n\
#        }\n\
#        tkPostOverPoint $menu $x $y [tkMenuFindName $menu [$w cget -text]]\n\
#    } else {\n\
        $menu post [winfo rootx $w] [expr [winfo rooty $w]+[winfo height $w]]\n\
#    }\n\
    focus $menu\n\
    tkSaveGrabInfo $w\n\
    grab -global $w\n\
    bind $w <ButtonRelease-1> {mtk_ImbUnpost {} }\n\
    bind $w <ButtonPress-1> {mtk_ImbUnpost {} }\n\
}\n\
\n\
proc mtk_ImbUnpost menu {\n\
    global tkPriv\n\
    set mb $tkPriv(postedMb)\n\
 \n\
    # Restore focus right away (otherwise X will take focus away when\n\
    # the menu is unmapped and under some window managers (e.g. olvwm)\n\
    # we'll lose the focus completely).\n\
 \n\
    catch {focus $tkPriv(focus)}\n\
    set tkPriv(focus) \"\"\n\
 \n\
    # Unpost menu(s) and restore some stuff that's dependent on\n\
    # what was posted.\n\
 \n\
    catch {\n\
        if {$mb != \"\"} {\n\
            set menu [$mb.workaround configure -menu]\n\
            $menu unpost\n\
            set tkPriv(postedMb) {}\n\
            $mb configure -cursor $tkPriv(cursor)\n\
            $mb configure -relief $tkPriv(relief)\n\
        } elseif {$tkPriv(popup) != \"\"} {\n\
            $tkPriv(popup) unpost\n\
            set tkPriv(popup) {}\n\
        } elseif {[wm overrideredirect $menu]} {\n\
            # We're in a cascaded sub-menu from a torn-off menu or popup.\n\
            # Unpost all the menus up to the toplevel one (but not\n\
            # including the top-level torn-off one) and deactivate the\n\
            # top-level torn off menu if there is one.\n\
 \n\
            while 1 {\n\
                set parent [winfo parent $menu]\n\
                if {([winfo class $parent] != \"Menu\")\n\
                        || ![winfo ismapped $parent]} {\n\
                    break\n\
                }\n\
                $parent activate none\n\
                $parent postcascade none\n\
                if {![wm overrideredirect $parent]} {\n\
                    break\n\
                }\n\
                set menu $parent\n\
            }\n\
            $menu unpost\n\
        }\n\
    }\n\
 \n\
    # Release grab, if any, and restore the previous grab, if there\n\
    # was one.\n\
 \n\
    if {$menu != \"\"} {\n\
        set grab [grab current $menu]\n\
        if {$grab != \"\"} {\n\
            grab release $grab\n\
        }\n\
    }\n\
\n\
    catch {\n\
      if {$tkPriv(oldGrab) != \"\"} {\n\
        if {$tkPriv(grabStatus) == \"global\"} {\n\
            grab set -global $tkPriv(oldGrab)\n\
        } else {\n\
            grab set $tkPriv(oldGrab)\n\
        }\n\
        set tkPriv(oldGrab) \"\"\n\
      }\n\
    }\n\
}\n\
\n\
proc iconbutton {args} {\n\
    set name [lindex $args 0]\n\
    global $name\n\
    set [set name](state) normal\n\
    set borderwidth 2\n\
    set relief flat\n\
    set command \"\"\n\
    set text \"\"\n\
    set bitmap \"\"\n\
    set menu \"\"\n\
    set width \"\"\n\
    set font \"\"\n\
    \n\
    for {set i 1} {$i < [llength $args]} {incr i} {\n\
	case [lindex $args $i] in {	\n\
	    \"-borderwidth\" {set borderwidth [lindex $args [expr $i+1]];incr i}\n\
	    \"-text\" {set text [lindex $args [expr $i+1]];incr i}\n\
	    \"-bitmap\" {set bitmap [lindex $args [expr $i+1]];incr i}\n\
	    \"-relief\" {set relief [lindex $args [expr $i+1]];incr i}\n\
	    \"-command\" {set command [lindex $args [expr $i+1]];incr i}\n\
	    \"-width\" {set width [lindex $args [expr $i+1]];incr i}\n\
	    \"-menu\" {set menu [lindex $args [expr $i+1]];incr i}\n\
	    \"-font\" {set font [lindex $args [expr $i+1]];incr i}\n\
	    \"-state\" {set [set name](state) [lindex $args [expr $i+1]];incr i}\n\
	    default {puts \"Unknown option [lindex $args $i] to iconbutton $name\"}\n\
	}\n\
    }\n\
    frame $name -relief flat -borderwidth 0\n\
    frame $name.f -relief $relief -borderwidth $borderwidth\n\
    pack $name.f -side top -fill both\n\
    label $name.f.bm -bitmap $bitmap -borderwidth 0 \n\
    pack $name.f.bm -side left -fill y -ipady 2\n\
    label $name.f.text -text $text -borderwidth 0 -pady 2\n\
    if {$width!=\"\"} {$name.f.text configure -width $width}\n\
    if {$font!=\"\"} {$name.f.text configure -font $font}\n\
    pack $name.f.text -side left -fill both -expand true -ipady 2\n\
\n\
    bind $name.f.bm <Enter> \\\n\
	\"highlight_iconbutton $name [option get . activeBackground Sdr]\"\n\
    bind $name.f.text <Enter> \\\n\
	\"highlight_iconbutton $name [option get . activeBackground Sdr]\"\n\
    if {$menu==\"\"} {\n\
	bind $name.f.bm <ButtonPress-1> \\\n\
	    \"$name.f configure -relief sunken;pack_iconbits $name\"\n\
	bind $name.f.text <ButtonPress-1> \\\n\
	    \"$name.f configure -relief sunken;pack_iconbits $name\"\n\
	bind $name.f.bm <ButtonRelease-1> \\\n\
	    \"$command;$name.f configure -relief $relief;pack_iconbits $name\"\n\
	bind $name.f.text <ButtonRelease-1> \\\n\
	    \"$command;$name.f configure -relief $relief;pack_iconbits $name\"\n\
	bind $name.f.bm <Leave> \\\n\
	    \"highlight_iconbutton $name [option get . background Sdr]\"\n\
	bind $name.f.text <Leave> \\\n\
	    \"highlight_iconbutton $name [option get . background Sdr]\"\n\
    } else {\n\
	bind $name.f.bm <ButtonPress-1> \\\n\
	    \"mtk_ImbPost $name\"\n\
	bind $name.f.text <ButtonPress-1> \\\n\
	    \"mtk_ImbPost $name\"\n\
	bind $name.f.bm <Leave> \\\n\
	    \"highlight_iconbutton $name [option get . background Sdr]\"\n\
	bind $name.f.text <Leave> \\\n\
	    \"highlight_iconbutton $name [option get . background Sdr]\"\n\
    }\n\
    proc $name.workaround {args} [format {\n\
	global %s\n\
#	puts $args\n\
	case [lindex $args 0] in {\n\
	    {config configure} {\n\
		if {[llength $args]==2} {\n\
		    case [lindex $args 1] in {\n\
			\"-relief\" {return [%s.f config -relief]}\n\
			\"-state\" {set st [set %s(state)];return \"$st\"}\n\
			\"-menu\" {return \"%s\"}\n\
		    }\n\
		} else {\n\
		    set ix 1\n\
		    while {$ix < [llength $args]} {\n\
			case [lindex $args $ix] in {\n\
			    \"-relief\" {\n\
				%s.f configure -relief \\\n\
				    [lindex $args [expr $ix + 1]]\n\
			    }\n\
			    \"-state\" {\n\
				set %s(state) [lindex $args [expr $ix + 1]]\n\
				case [lindex $args [expr $ix + 1]] in {\n\
				    normal {\n\
					%s.f.bm configure -foreground \\\n\
					    [option get . foreground Sdr]\n\
					%s.f.text configure -foreground \\\n\
					    [option get . foreground Sdr]\n\
				    }\n\
				    disabled {\n\
					%s.f.bm configure -foreground \\\n\
					    [option get . disabledForeground Sdr]\n\
					%s.f.text configure -foreground \\\n\
					    [option get . disabledForeground Sdr]\n\
				    }\n\
				}\n\
			    }\n\
			}\n\
			incr ix 2\n\
		    }\n\
		}\n\
	    }\n\
	}\n\
    } $name $name $name $menu $name $name $name $name $name $name]\n\
}\n\
\n\
\n\
\n\
proc highlight_iconbutton {name col} {\n\
    global $name\n\
    if {[set [set name](state)]!=\"disabled\"} {\n\
	$name.f.bm configure -background $col\n\
	$name.f.text configure -background $col\n\
    }\n\
}\n\
\n\
proc pack_iconbits {name} {\n\
    #shouldn't need this, but there's a bug in the packer...\n\
    pack $name.f.bm -side left\n\
    pack $name.f.text -side left -fill both -expand true\n\
}\n\
\n\
proc wnamemap {wname textname} {\n\
    global wmappings\n\
    set wmappings($wname) $textname\n\
}\n\
\n\
proc tw {wname} {\n\
    global wmappings\n\
    set tmp $wname\n\
    catch {set tmp $wmappings($wname)}\n\
    return $tmp\n\
}\n\
\n\
proc password {args} {\n\
    if {[llength $args] < 1} { return }\n\
    set win [lindex $args 0]\n\
    set width 10\n\
    set relief sunken\n\
    set borderwidth 2\n\
    set background [option get . background Sdr]\n\
    set font [option get . font Sdr]\n\
    set variable \"\"\n\
    set command break\n\
    set ix 2\n\
    foreach a [lrange $args 1 end] {\n\
        case $a in {\n\
            \"-width\" { set width [lindex $args $ix] }\n\
            \"-relief\" { set relief [lindex $args $ix] }\n\
            \"-background\" { set background [lindex $args $ix] }\n\
            \"-borderwidth\" { set borderwidth [lindex $args $ix] }\n\
            \"-variable\" { set variable [lindex $args $ix] }\n\
            \"-font\" {set font [lindex $args $ix] }\n\
            \"-command\" {set command [lindex $args $ix] }\n\
        }\n\
        incr ix\n\
    }\n\
    entry $win -width $width \\\n\
        -background $background \\\n\
        -borderwidth $borderwidth \\\n\
        -relief $relief \\\n\
        -font $font\n\
    global $variable\n\
    set $variable \"\"\n\
    bind $win <Any-KeyPress> \"add_password_char $win $variable %A;break\"\n\
    bind $win <Delete> \"del_password_char $win $variable;break\"\n\
    bind $win <Return> $command\n\
    proc $win.workaround {args} [format {\n\
        if {[lindex $args 0]==\"set\"} {\n\
            set_password_chars %s %s [lindex $args 1]\n\
        }\n\
    } $win $variable]\n\
}\n\
 \n\
proc set_password_chars {win var chs} {\n\
    global $var\n\
    set $var $chs\n\
    $win delete 0 end\n\
    for {set i 0} {$i < [string length $chs]} {incr i} {\n\
        $win insert 0 \"*\"\n\
    }\n\
}\n\
 \n\
proc add_password_char {win var ch} {\n\
    global $var\n\
    set v [set $var]\n\
    if {[is_printable $ch]} {\n\
        set v \"$v$ch\"\n\
        $win insert end \"*\"\n\
        $win icursor end\n\
        set $var $v\n\
    }\n\
}\n\
 \n\
proc del_password_char {win var} {\n\
    global $var\n\
    set v [set $var]\n\
    set last [expr [string length $v] - 2]\n\
    set v [string range $v 0 $last]\n\
    $win delete 0 1\n\
    set $var $v\n\
}\n\
 \n\
proc is_printable {ch} {\n\
    if {[string length $ch]==1} {\n\
        scan $ch %c c\n\
        if {$c < 32} {\n\
            return 0\n\
        }\n\
        return 1\n\
    }\n\
    return 0\n\
}\n\
";
