char NT_UI[] = "\
#source location\n\
#set src_dir /cs/research/mice/speedy/home/mhandley/tcl\n\
#source $src_dir/net_balloon.tcl\n\
\n\
#Use same colours as vat\n\
#general\n\
option add *background gray80 widgetDefault\n\
option add *foreground black widgetDefault\n\
option add *activeBackground gray95 widgetDefault\n\
option add *selectBackground gray95 widgetDefault\n\
option add *scrollbarBackground gray50 widgetDefault\n\
option add *scrollbarForeground gray80 widgetDefault\n\
option add *scrollbarActiveForeground gray95 widgetDefault\n\
option add *canvasBackground gray95 widgetDefault\n\
#option add *tixBalloonBg gray50\n\
#option add *tixBalloonFg white\n\
#test\n\
option add *disabledBackground gray80 widgetDefault\n\
option add *disabledForeground gray50 widgetDefault\n\
option add *hotForeground blue widgetDefault\n\
option add *activehotForeground red widgetDefault\n\
option add *balloonHelp 0\n\
option add *fontSize normal widgetDefault\n\
option add *participants 1 widgetDefault\n\
option add *font \\\n\
  -*-helvetica-bold-r-normal--12-*-iso8859-1 \\\n\
  widgetDefault\n\
option add *ntInfoFont \\\n\
  -*-helvetica-medium-r-normal--10-*-iso8859-1 \\\n\
  widgetDefault\n\
option add *ntUserFont \\\n\
  -*-helvetica-bold-r-normal--10-*-iso8859-1 \\\n\
  widgetDefault\n\
option add *mediumFont \\\n\
  -*-helvetica-bold-r-normal--10-*-iso8859-1 \\\n\
  widgetDefault\n\
set balloonHelp 0\n\
#if { [option get . balloonHelp nt] == 0 } {\n\
#  tixBalloonManual  \n\
#  set balloonHelp 0\n\
#}\n\
set infofont [option get . ntInfoFont nt]\n\
set userfont [option get . ntUserFont nt]\n\
set backcol [option get . background nt]\n\
set canvcol [option get . canvasBackground nt]\n\
set webproxy \"\"\n\
lognewwindow .\n\
frame .m\n\
#frame .m.top -borderwidth 2 -relief sunken\n\
frame .m.cp -borderwidth 2 -relief groove\n\
frame .m.in -borderwidth 2 -relief groove\n\
frame .m.l\n\
frame .m.l.ss -borderwidth 2 -relief groove\n\
frame .m.l.txt -borderwidth 2 -relief sunken\n\
\n\
\n\
label .m.cp.l -text \"UCL Network Text Editor V1.5a23\"\n\
\n\
menubutton .m.cp.file -text \"File\" -width 6 -menu .m.cp.file.m -relief raised \\\n\
    -borderwidth 1\n\
menu .m.cp.file.m -tearoff 0\n\
.m.cp.file.m add command -label \"Load Plain Text\" -command \"load_text plain\"\n\
.m.cp.file.m add command -label \"Load Structured Text\" -command \"load_text struct\"\n\
.m.cp.file.m add command -label \"Save Plain Text\" -command \"save_text plain\"\n\
.m.cp.file.m add command -label \"Save Structured Text\" -command \"save_text struct\"\n\
.m.cp.file.m add command -label \"Quit\" -command \"quit\"\n\
\n\
menubutton .m.cp.edit -text \"Edit\" -width 6 -relief raised -borderwidth 1 \\\n\
    -menu .m.cp.edit.m\n\
menu .m.cp.edit.m -tearoff 0\n\
.m.cp.edit.m add command -label \"Undo\" -command undo -state disabled\n\
.m.cp.edit.m add command -label \"Delete Block\" \\\n\
    -command {try_to_delete_block $cur_block}\n\
.m.cp.edit.m add command -label \"Lower Block (Ctrl-L)\" \\\n\
    -command {lower_block $cur_block}\n\
\n\
menubutton .m.cp.col -text Colour -width 6 -menu .m.cp.col.m -relief raised \\\n\
    -borderwidth 1\n\
menu .m.cp.col.m -activeforeground grey -tearoff 0\n\
set cur_col 7\n\
set colours {red orange3 yellow3 forestgreen blue magenta purple black}\n\
set i 0\n\
foreach coli $colours {\n\
    set col($i) $coli\n\
    .m.cp.col.m add command -label $coli -background $coli \\\n\
	-activebackground $coli -command \"set_col $i\"\n\
    incr i\n\
}\n\
\n\
menubutton .m.cp.font -text Font -width 6 -menu .m.cp.font.m -relief raised \\\n\
    -borderwidth 1\n\
menu .m.cp.font.m -tearoff 0\n\
set fonts {\\\n\
-adobe-courier-medium-r-normal--*-120-75-75-*-*-*-*\\\n\
-adobe-courier-medium-o-normal--*-120-75-75-*-*-*-*\\\n\
-adobe-courier-bold-r-normal--*-120-75-75-*-*-*-*\\\n\
-adobe-courier-bold-o-normal--*-120-75-75-*-*-*-*}\n\
set mediumfonts {\\\n\
-adobe-courier-medium-r-normal--14-*-iso8859-1 \\\n\
-adobe-courier-medium-o-normal--14-*-iso8859-1 \\\n\
-adobe-courier-bold-r-normal--14-*-iso8859-1 \\\n\
-adobe-courier-bold-o-normal--14-*-iso8859-1 }\n\
set largefonts {\\\n\
-adobe-courier-medium-r-normal--24-*-iso8859-1\n\
-adobe-courier-medium-o-normal--24-*-iso8859-1 \\\n\
-adobe-courier-bold-r-normal--24-*-iso8859-1 \\\n\
-adobe-courier-bold-o-normal--24-*-iso8859-1 }\n\
set fontnames {\\\n\
Normal \\\n\
Italic \\\n\
Bold \\\n\
\"Bold Italic\"}\n\
set i 0\n\
foreach fontn $fontnames {\n\
    set fontname($i) $fontn\n\
    incr i\n\
}\n\
set i 0\n\
set cur_font 2\n\
set fontsize [option get . fontSize nt]\n\
#these should really be derived automatically\n\
if {$fontsize==\"normal\"} {\n\
    set fw 7\n\
    set fh 13 \n\
    set currentfonts $fonts\n\
} elseif {$fontsize==\"medium\"} {\n\
    set fw 9\n\
    set fh 15\n\
    set currentfonts $mediumfonts\n\
} else {\n\
    set fw 7\n\
    set fh 13\n\
    set currentfonts $fonts\n\
}\n\
#set fw 15\n\
#set fh 23\n\
foreach fonti $currentfonts {\n\
    set font($i) $fonti\n\
    .m.cp.font.m add command -label $fontname($i) -font $fonti \\\n\
	-command \"set_font $i\"\n\
    incr i\n\
}\n\
\n\
menubutton .m.cp.show -text Show -width 6 -menu .m.cp.show.m  -relief raised \\\n\
    -borderwidth 1\n\
menu .m.cp.show.m -tearoff 0\n\
set part_vis [option get . participants nt]\n\
.m.cp.show.m add checkbutton -label \"Participants\" -variable part_vis \\\n\
    -command {show_participants $part_vis}\n\
set block_vis 1\n\
.m.cp.show.m add checkbutton -label \"Current Block Info\" -variable block_vis \\\n\
    -command {show_block_info $block_vis}\n\
\n\
button .m.cp.help -text Help -width 6 -relief raised \\\n\
    -borderwidth 1 -command {webdisp help:about} -padx 3 -pady 3\n\
\n\
pack .m.cp.file .m.cp.edit .m.cp.col .m.cp.font .m.cp.show -side left\n\
pack .m.cp.help -side right -padx 0 -pady 0\n\
pack .m.cp.l -side right -expand true -fill x\n\
\n\
\n\
label .m.in.l -text \"Block:\" -font $infofont\n\
label .m.in.bid -text \"None\" -font $infofont -width 16 -relief sunken \\\n\
    -borderwidth 1\n\
label .m.in.cl -text \"Created by:\" -font $infofont\n\
label .m.in.cid -text \"\" -font $infofont -width 20 -relief sunken \\\n\
    -borderwidth 1\n\
label .m.in.ml -text \"Changed by:\" -font $infofont\n\
label .m.in.mid -text \"\" -font $infofont -width 20 -relief sunken \\\n\
    -borderwidth 1\n\
label .m.in.mtl -text \" at:\" -font $infofont\n\
label .m.in.mt -text \"00:00\" -font $infofont -width 5 -relief sunken \\\n\
    -borderwidth 1\n\
label .m.in.lck -bitmap \"unlocked\" -font $infofont -width 6\n\
\n\
\n\
pack .m.in.l .m.in.bid -side left\n\
pack  .m.in.lck -side left -ipadx 10\n\
pack .m.in.cl .m.in.cid  \\\n\
    .m.in.ml .m.in.mid  \\\n\
    .m.in.mtl .m.in.mt -side left\n\
\n\
proc show_block_info {flag} {\n\
    if {$flag==1} {\n\
	pack .m.in -side top -after .m.cp -fill x\n\
    } else {\n\
	pack forget .m.in\n\
    }\n\
}\n\
############################################\n\
#Session window stuff\n\
############################################\n\
frame .m.l.ss.l -borderwidth 0\n\
button .m.l.ss.l.l -text \"Participants\" -command hide_participants \\\n\
    -relief flat\n\
set keep_users FALSE\n\
checkbutton .m.l.ss.l.keep -text \"Keep\" -command {ui_keep_userlist $keep_users} \\\n\
    -relief flat -variable keep_users -onvalue TRUE -offvalue FALSE\\\n\
    -font $infofont -borderwidth 1\n\
frame .m.l.ss.f -relief sunken -borderwidth 2\n\
scrollbar .m.l.ss.f.sb\n\
text .m.l.ss.f.lb -width 20 -height 20 -relief flat -font $userfont \\\n\
    -yscroll \".m.l.ss.f.sb set\" -wrap none -borderwidth 0\n\
.m.l.ss.f.sb configure -command \".m.l.ss.f.lb yview\" \\\n\
    -background [option get . background Mtool] \\\n\
    -troughcolor [option get . scrollbarBackground Mtool] \\\n\
    -borderwidth 1 -relief flat\n\
bind .m.l.ss.f.lb <KeyPress> \"break\"\n\
bind .m.l.ss.f.lb <B1-Motion> \"break\"\n\
bind .m.l.ss.f.lb <1> \"break\"\n\
.m.l.ss.f.lb tag configure inactive -foreground [option get . disabledForeground nt]\n\
wnamemap .m.l.ss.f.lb participants-list\n\
wnamemap .m.l.ss.f.sb participants-list-scrollbar\n\
checkbutton .m.l.ss.readonly -text \"Read Only\" -relief flat \\\n\
    -font $userfont -borderwidth 1 -command {set_readable_mode $readonly} \\\n\
    -anchor w -highlightthickness 0\n\
checkbutton .m.l.ss.locking -text \"Lock New Items\" -relief flat \\\n\
    -font $userfont -borderwidth 1 -command {set_lock_mode $locking} \\\n\
    -anchor w -highlightthickness 0\n\
checkbutton .m.l.ss.encrypt -text \"Encrypt Session\" -relief flat \\\n\
    -font $userfont -borderwidth 1 -command {set_key $encrypt} \\\n\
    -anchor w -highlightthickness 0\n\
label .m.l.ss.logo -bitmap \"ucl\"\n\
pack .m.l.ss.f.lb -side left -fill both -anchor nw\n\
pack .m.l.ss.f.sb -side right -fill y \n\
pack .m.l.ss.l -side top -fill x\n\
pack .m.l.ss.l.l -side left -fill both\n\
pack .m.l.ss.l.keep -side top -fill y -expand true -padx 0 -ipadx 0\n\
pack .m.l.ss.f -side top -fill both\n\
pack .m.l.ss.readonly -side top -anchor w -fill x\n\
pack .m.l.ss.locking -side top -anchor w -fill x -pady 0 -ipady 0\n\
pack .m.l.ss.encrypt -side top -anchor w -fill x -pady 0 -ipady 0\n\
pack .m.l.ss.logo -side top -anchor w\n\
\n\
proc hide_participants {} {\n\
    global part_vis\n\
    pack forget .m.l.ss\n\
    set part_vis 0\n\
}\n\
proc show_participants {flag} {\n\
    if {$flag==1} {\n\
	pack .m.l.ss -before .m.l.txt -side right -fill both\n\
    } else {\n\
	pack forget .m.l.ss\n\
    }\n\
}\n\
############################################\n\
#Canvas stuff\n\
############################################\n\
\n\
set canvypos 0\n\
canvas .m.l.txt.c -height [expr 40 * $fh] -width [expr 90 * $fw] \\\n\
    -relief flat \\\n\
    -yscrollincrement $fh -background $canvcol \\\n\
    -confine true\n\
scrollbar .m.l.txt.sb -command \"scroll_canvas\" \\\n\
    -background [option get . background Mtool] \\\n\
    -troughcolor [option get . scrollbarBackground Mtool] \\\n\
    -borderwidth 1 \n\
wnamemap .m.l.txt.c main-editor-panel\n\
wnamemap .m.l.txt.sb main-editor-panel-scrollbar\n\
.m.l.txt.c addtag margin withtag \\\n\
    [.m.l.txt.c create line [expr 90 * $fw] 0 [expr 90 * $fw] 520\\\n\
    -stipple dashed -width 3]\n\
\n\
#activity indicator\n\
set activity_indicator \".m.l.ss.c2\"\n\
canvas $activity_indicator -width 20 -height 150 \\\n\
    -background $backcol -relief sunken -borderwidth 2\n\
pack $activity_indicator -side top -fill both\n\
$activity_indicator addtag win withtag \\\n\
    [$activity_indicator create rectangle 0 0 100 [expr 40 * $fh] \\\n\
     -fill $canvcol]\n\
wnamemap .m.l.ss.c2 minimap\n\
\n\
proc set_activity {max height top bottom} {\n\
    global c2max c2top c2bottom c2height c2width activity_indicator\n\
    set c2height [lindex [$activity_indicator configure -height] 4]\n\
    set c2width [lindex [$activity_indicator configure -width] 3]\n\
    set y1 [expr (($top * $c2height) / $max)]\n\
    set y2 [expr (($bottom * $c2height) / $max)]\n\
    $activity_indicator coords win 0 $y1 $c2width $y2\n\
    set c2max $max\n\
    set c2top $top\n\
    set c2bottom $bottom\n\
}\n\
\n\
#set c2ctr 0\n\
proc indicate_activity {id y pcol} {\n\
    global col activity_indicator\n\
    global c2max c2top c2bottom c2height c2width c2markers\n\
    set y1 [expr ($y * $c2height) / $c2max]\n\
    set code [catch {set tmp $c2markers($id)}]\n\
    if {$code==0} {\n\
	set c2markers($id) 1\n\
	$activity_indicator coords $id 0 $y1 $c2width [expr $y1 + 10]\n\
	return\n\
    }\n\
    set c2markers($id) 1\n\
    $activity_indicator addtag $id withtag \\\n\
	[$activity_indicator create rectangle 0 $y1 20 [expr $y1 + 10] \\\n\
	 -fill $col($pcol)]\n\
    after 5000 \"$activity_indicator delete $id; unset c2markers($id)\"\n\
#    incr c2ctr\n\
}\n\
\n\
proc gc_dummy {a b c d} {\n\
    grow_canvas\n\
}\n\
proc int {i} {\n\
    return [lindex [split $i \".\"] 0]\n\
}\n\
proc grow_canvas {} {\n\
    global fw fh canvypos\n\
    set ymax [lindex [.m.l.txt.c bbox all] 3]\n\
    if {$ymax == \"\"} { set ymax 0.0 }\n\
    set top [.m.l.txt.c canvasy 0]\n\
    set canvypos [int $top]\n\
    set height [lindex [.m.l.txt.c configure -height] 4]\n\
    set bottom [.m.l.txt.c canvasy $height]\n\
    if { ($ymax < $bottom) && ($ymax<$height) } {\n\
	set ymax $bottom\n\
    }\n\
    .m.l.txt.c configure -scrollregion \"0.0 0.0 520.0 $ymax\"\n\
    if {$top < -$fh} {\n\
	.m.l.txt.c yview scroll [expr -[int $top]/$fh] units\n\
#	puts \"at top\"\n\
    }\n\
    if {$ymax <= $bottom} {\n\
	.m.l.txt.c yview moveto [expr 1.0-($height.0/$ymax)]\n\
#	puts \"at bottom\"\n\
    }\n\
    .m.l.txt.sb set [lindex [.m.l.txt.c yview] 0] [lindex [.m.l.txt.c yview] 1]\n\
    set_activity $ymax $height $top $bottom\n\
    .m.l.txt.c coords margin [expr 90 * $fw] 0 [expr 90 * $fw] [expr $ymax -4]\n\
}\n\
\n\
#call it now to initialise the scrollbar...\n\
#update\n\
#grow_canvas\n\
\n\
\n\
proc scroll_canvas args {\n\
    eval \".m.l.txt.c yview $args\"\n\
    grow_canvas\n\
}\n\
\n\
#  -font -Adobe-Courier-Bold-R-Normal-*-120-* \\\n\
#  -yscroll \".m.l.txt.sb set\" -wrap none\n\
#scrollbar .m.l.txt.sb -command \".m.l.txt.t yview\" \\\n\
#  -background [option get . scrollbarBackground Mtool] \\\n\
#  -foreground [option get . scrollbarForeground Mtool] \\\n\
#  -activeforeground [option get . scrollbarActiveForeground Mtool]\n\
\n\
proc set_info_display {} {\n\
    global cur_block\n\
    set creator [ui_get_creator $cur_block]\n\
    set user [lindex [split $creator \"@\"] 0]\n\
#catch all this in case we have problems with deleted blocks\n\
    catch {\n\
	.m.in.bid configure -text $user:[string range $cur_block 9 end]\n\
	.m.in.cid configure -text $creator\n\
	.m.in.mid configure -text [ui_get_modifier $cur_block]\n\
	.m.in.mt configure -text [ui_get_modification_time $cur_block]\n\
	.m.in.bid configure -foreground \\\n\
	    [ lindex \\\n\
	     [.m.l.txt.c itemconfigure $cur_block -fill] \\\n\
		 4]\n\
	if {[ui_get_lock_status $cur_block] == \"LOCKED\"} {\n\
	    .m.in.lck configure -bitmap locked\n\
	} else {\n\
	    .m.in.lck configure -bitmap \"unlocked\"\n\
	}\n\
    }\n\
}\n\
proc insertWithTags {w text args} {\n\
    set start [$w index insert]\n\
    $w insert insert $text\n\
    foreach tag [$w tag names $start] {\n\
        $w tag remove $tag $start insert\n\
    }\n\
    foreach i $args {\n\
        $w tag add $i $start insert\n\
    }\n\
}\n\
\n\
#insertWithTags .m.l.txt.t {                                                                              \n\
#} blank\n\
\n\
set cur_block bid0\n\
set cur_line 0\n\
#Emacs command bindings\n\
bind .m.l.txt.c <Any-KeyPress>  \"insert_char %x %y %A \"\n\
\n\
bind .m.l.txt.c <Control-a> move_linestart\n\
bind .m.l.txt.c <Control-e> move_lineend\n\
bind .m.l.txt.c <Control-n> move_down\n\
bind .m.l.txt.c <Down> move_down\n\
bind .m.l.txt.c <Control-p> move_up\n\
bind .m.l.txt.c <Up> move_up\n\
bind .m.l.txt.c <Control-f> move_fwd\n\
bind .m.l.txt.c <Right> move_fwd\n\
bind .m.l.txt.c <Meta-f> move_fwd\n\
bind .m.l.txt.c <Control-b> move_bwd\n\
bind .m.l.txt.c <Left> move_bwd\n\
bind .m.l.txt.c <Meta-b> move_bwd\n\
bind .m.l.txt.c <Control-v> page_down\n\
bind .m.l.txt.c <Meta-v> page_up\n\
bind .m.l.txt.c <Control-k> delete_to_end_of_line\n\
bind .m.l.txt.c <Control-y> insert_cut_buffer\n\
bind .m.l.txt.c <Control-d> \"move_fwd;delete_char\"\n\
bind .m.l.txt.c <Control-l> {lower_block $cur_block}\n\
bind .m.l.txt.c <Return> insert_cr\n\
bind .m.l.txt.c <Delete> {delete_char;break}\n\
bind .m.l.txt.c <BackSpace> {delete_char;break}\n\
#bind .m.l.txt.c <Control-@> set_mark\n\
bind .m.l.txt.c <Control-w> delete_from_mark\n\
bind .m.l.txt.c <Meta-Delete> delete_char\n\
#bind .m.l.txt.c <Meta-\\>> end_of_block\n\
#bind .m.l.txt.c <Meta-<> start_of_block\n\
\n\
bind .m.l.txt.c <1> {findblock %x [expr %y + $canvypos]}\n\
if {$tcl_platform(platform)==\"unix\"} {\n\
    bind .m.l.txt.c  <B2-Motion> {moveblock %x [expr %y + $canvypos]}\n\
    bind .m.l.txt.c <ButtonRelease-2> {grow_canvas;clear_move_block}\n\
} else {\n\
    bind .m.l.txt.c  <Shift-B1-Motion> {moveblock %x [expr %y + $canvypos]}\n\
    bind .m.l.txt.c <Shift-ButtonRelease-1> {grow_canvas;clear_move_block}\n\
}\n\
bind .m.l.txt.c <Control-i> ui_print_ds\n\
bind .m.l.txt.c <3> {create_my_shared_pointer %x [expr %y + $canvypos]}\n\
bind .m.l.txt.c <B3-Motion> {move_my_shared_pointer %x [expr %y + $canvypos]}\n\
bind .m.l.txt.c <ButtonRelease-3> {delete_my_shared_pointer}\n\
\n\
proc set_readable_mode {flag} {\n\
    if {$flag==1} {\n\
	read_only\n\
    } else {\n\
	read_write\n\
    }\n\
}\n\
\n\
proc read_only {} {\n\
    bind .m.l.txt.c <Any-KeyPress> \"\"\n\
    bind .m.l.txt.c <Return> \"\"\n\
    bind .m.l.txt.c <Delete> \"\"\n\
    bind .m.l.txt.c <B2-Motion> \"\"\n\
    bind .m.l.txt.c <1> \"\"\n\
    pack forget .m.cp.edit\n\
    pack forget .m.cp.font\n\
    pack forget .m.cp.col\n\
}\n\
\n\
proc read_write {} {\n\
    bind .m.l.txt.c <Any-KeyPress>  \"insert_char %x %y %A \"\n\
    bind .m.l.txt.c <Return> insert_cr\n\
    bind .m.l.txt.c <Delete> delete_char\n\
    bind .m.l.txt.c  <B2-Motion> {moveblock %x [expr %y + $canvypos]}\n\
    bind .m.l.txt.c <1> {findblock %x [expr %y + $canvypos]}\n\
    pack .m.cp.edit -side left -after .m.cp.file\n\
    pack .m.cp.col -side left -after .m.cp.edit\n\
    pack .m.cp.font -side left -after .m.cp.col\n\
}\n\
\n\
proc set_lock_mode {flag} {\n\
    if {$flag==1} {\n\
	ui_set_lock_mode LOCKED\n\
    } else {\n\
	ui_set_lock_mode NORMAL\n\
    }\n\
}\n\
\n\
proc set_col {coli} {\n\
    global cur_block\n\
    global col\n\
    global cur_col\n\
    set cur_col $coli\n\
    ui_set_my_colour $cur_col\n\
    if {[ui_get_my_lock_status $cur_block] == \"LOCKED\" } { \n\
	display_lock $cur_block\n\
	return \n\
    }\n\
    .m.l.txt.c itemconfigure $cur_block -fill $col($coli)\n\
    ui_set_block_colour $cur_block $coli\n\
    set_info_display\n\
}\n\
\n\
proc set_font {fonti} {\n\
    global cur_block\n\
    global font\n\
    global cur_font\n\
    if {[ui_get_my_lock_status $cur_block] == \"LOCKED\" } { \n\
	display_lock $cur_block\n\
	return \n\
    }\n\
    .m.l.txt.c itemconfigure $cur_block -font $font($fonti)\n\
    set cur_font $fonti\n\
    ui_set_block_font $cur_block $fonti\n\
    set_info_display\n\
}\n\
\n\
proc set_posn {x y} {\n\
    global cur_block\n\
    global fw fh\n\
    ui_set_block_posn $cur_block [expr $x/$fw] [expr $y/$fh]\n\
}\n\
\n\
set last_line 0\n\
\n\
\n\
proc findblock {x y} {\n\
  global cur_block\n\
#  puts findblock\n\
  new_block $x $y\n\
}\n\
\n\
#called from C to undisplay the block\n\
proc delete_block {id} {\n\
    .m.l.txt.c itemconfigure $id -stipple gray75\n\
    after 250 .m.l.txt.c itemconfigure $id -stipple gray50\n\
    after 500 .m.l.txt.c itemconfigure $id -stipple gray33\n\
    after 750 .m.l.txt.c itemconfigure $id -stipple gray25\n\
    after 1000 .m.l.txt.c delete $id\n\
}\n\
\n\
#called from menu to actually delete it\n\
proc try_to_delete_block {id} {\n\
    global xpos ypos fw fh cur_col\n\
    if {[ui_get_my_lock_status $id] == \"LOCKED\"} {\n\
	display_lock $id\n\
	return\n\
    } else {\n\
	ui_send_shared_pointer [expr $xpos($id) * $fw] \\\n\
	    [expr $ypos($id) * $fh] $cur_col eraser\n\
	after 250 ui_send_shared_pointer [expr $xpos($id) * $fw + 20] \\\n\
	    [expr $ypos($id) * $fh]  $cur_col eraser\n\
	after 500 ui_send_shared_pointer [expr $xpos($id) * $fw + 40] \\\n\
	    [expr $ypos($id) * $fh] $cur_col eraser\n\
	after 750 ui_send_shared_pointer [expr $xpos($id) * $fw + 20] \\\n\
	    [expr $ypos($id) * $fh] $cur_col eraser\n\
	after 1000 ui_send_shared_pointer [expr $xpos($id) * $fw] \\\n\
	    [expr $ypos($id) * $fh] $cur_col eraser\n\
	ui_delete_block $id\n\
	delete_block $id\n\
	grow_canvas\n\
    }\n\
}\n\
\n\
proc lower_block {id} {\n\
    .m.l.txt.c lower $id\n\
}\n\
proc startmoveblock {block x y} {\n\
    global cur_block fh fw\n\
    global cursor_x cursor_y\n\
    global xpos ypos\n\
    global fw fh\n\
    global px py\n\
    global move_block_end\n\
    global old_block\n\
    set lock [ui_get_my_lock_status $block]\n\
    if { $lock == \"LOCKED\" } { \n\
	set cur_block $block\n\
	display_lock $block\n\
	return \n\
    }\n\
    set move_block_end 0\n\
    set cursor_x [expr $x - ($xpos($block) * $fw)]\n\
    set cursor_y [expr $y - ($ypos($block) * $fh)]\n\
    set px 0\n\
    set py 0\n\
#    puts \"block: $block\"\n\
    set_cur_block $block $x $y\n\
    flash_block $block\n\
    set old_block 0\n\
    set_info_display\n\
}\n\
proc moveblock {x y} {\n\
    global cur_block fh fw\n\
    global cursor_x cursor_y xpos ypos\n\
    global cur_col\n\
    global px py\n\
    global move_block_end\n\
    set lock [ui_get_my_lock_status $cur_block]\n\
    if { $lock == \"LOCKED\" } { \n\
	display_lock $cur_block\n\
	return \n\
    }\n\
    if { $move_block_end == 1 } { return }\n\
    set nx [expr $x - $cursor_x]\n\
    set ny [expr $y - $cursor_y]\n\
    set nx [expr $nx -($nx%$fw)]\n\
    set ny [expr $ny -($ny%$fh)]\n\
    if {($nx < 0)} { set nx 0 }\n\
    if {($ny < 0)} { set ny 0 }\n\
    if {($nx!=$px)|($ny!=$py)} {\n\
	ui_send_shared_pointer $nx $ny $cur_col hand\n\
	set_posn $nx $ny\n\
	set px $nx\n\
	set py $ny\n\
	set xpos($cur_block) [expr $nx/$fw]\n\
	set ypos($cur_block) [expr $ny/$fh]\n\
#	puts \"pos: $xpos($cur_block),$ypos($cur_block)\"\n\
	.m.l.txt.c coords $cur_block $nx $ny\n\
    }\n\
}\n\
\n\
proc clear_move_block {} {\n\
    global move_block_end\n\
    set move_block_end 1\n\
}\n\
\n\
proc move_linestart {} {\n\
  global cur_block\n\
  set txt [lindex [.m.l.txt.c itemconfigure $cur_block -text] 4]\n\
  set pos [.m.l.txt.c index $cur_block insert]\n\
  set newpos [string last \"\\n\" [string range $txt 0 [expr $pos - 1]] ]\n\
  .m.l.txt.c icursor $cur_block [expr $newpos + 1]\n\
}\n\
\n\
proc move_lineend {} {\n\
  global cur_block\n\
  set txt [lindex [.m.l.txt.c itemconfigure $cur_block -text] 4]\n\
  set pos [.m.l.txt.c index $cur_block insert]\n\
  set newpos [string first \"\\n\" [string range $txt $pos end] ]\n\
  if {$newpos == -1} {\n\
      .m.l.txt.c icursor $cur_block end\n\
  } else {\n\
      .m.l.txt.c icursor $cur_block [expr $pos + $newpos]\n\
  }\n\
}\n\
\n\
proc move_fwd {} {\n\
  global cur_block\n\
  .m.l.txt.c icursor $cur_block [expr [.m.l.txt.c index $cur_block insert] + 1]\n\
}\n\
\n\
proc move_bwd {} {\n\
  global cur_block\n\
  .m.l.txt.c icursor $cur_block [expr [.m.l.txt.c index $cur_block insert] - 1]\n\
}\n\
proc move_up {} {\n\
  global cur_block\n\
  set txt [lindex [.m.l.txt.c itemconfigure $cur_block -text] 4]\n\
  set pos [.m.l.txt.c index $cur_block insert]\n\
  set newpos [string last \"\\n\" [string range $txt 0 [expr $pos - 1]] ]\n\
  if {$newpos == -1} { return }\n\
  set linepos [expr $pos - $newpos]\n\
  set prevstart [string last \"\\n\" [string range $txt 0 [expr $newpos - 1]] ]\n\
  .m.l.txt.c icursor $cur_block [expr $linepos + $prevstart]\n\
  set lnum [.m.l.txt.c index $cur_block yinsert]\n\
  move_up_out_of_window $cur_block $lnum\n\
\n\
}\n\
\n\
proc move_down {} {\n\
  global cur_block\n\
  set txt [lindex [.m.l.txt.c itemconfigure $cur_block -text] 4]\n\
  set pos [.m.l.txt.c index $cur_block insert]\n\
  set linestart [string last \"\\n\" [string range $txt 0 [expr $pos - 1]] ]\n\
  set nextstart [string first \"\\n\" [string range $txt $pos end ]]\n\
  set linepos [expr $pos - $linestart]\n\
  if {$nextstart==-1} {\n\
      return\n\
  }\n\
  .m.l.txt.c icursor $cur_block [expr $linepos + $nextstart + $pos]\n\
  set lnum [.m.l.txt.c index $cur_block yinsert]\n\
  move_down_out_of_window $cur_block $lnum\n\
\n\
}\n\
proc insert_cr {} {\n\
  global cur_block\n\
  global curline curlnum\n\
  set lock [ui_get_my_lock_status $cur_block]\n\
  if { $lock == \"LOCKED\" } { \n\
      display_lock $cur_block\n\
      return \n\
  }\n\
  set oldpos [.m.l.txt.c index $cur_block insert]\n\
  set oldlnum [.m.l.txt.c index $cur_block yinsert]\n\
  .m.l.txt.c insert $cur_block insert \"\\n\"\n\
\n\
  set pos [.m.l.txt.c index $cur_block insert]\n\
  set txt [lindex [.m.l.txt.c itemconfigure $cur_block -text] 4]\n\
  ui_new_line $cur_block $oldlnum\n\
\n\
  set lstart [.m.l.txt.c index $cur_block linestart]\n\
  set lend [.m.l.txt.c index $cur_block lineend]\n\
  set curline [string range $txt $lstart $lend]\n\
  set curlnum [.m.l.txt.c index $cur_block yinsert]\n\
  ui_set_line $cur_block $curlnum $curline\n\
\n\
  get_line $txt $oldpos\n\
  ui_set_line $cur_block $curlnum $curline\n\
\n\
  set_info_display\n\
  update\n\
\n\
#see whether this takes us off the bottom of the screen\n\
  move_down_out_of_window $cur_block $curlnum\n\
  update\n\
  grow_canvas\n\
}\n\
\n\
proc move_down_out_of_window {id lnum} {\n\
  global xpos ypos fh fw\n\
  set height [lindex [.m.l.txt.c configure -height] 4]\n\
  set bottom [.m.l.txt.c canvasy $height]\n\
  if {[expr $fh * ($lnum + $ypos($id) + 2)] > $bottom } {\n\
      set ymax [lindex [.m.l.txt.c bbox all] 3]\n\
      if {$ymax == \"\"} { set ymax 0.0 }\n\
      set top [expr ([.m.l.txt.c canvasy 0]+$fh) / $ymax]\n\
      .m.l.txt.c yview moveto $top\n\
      .m.l.txt.sb set [lindex [.m.l.txt.c yview] 0] [lindex [.m.l.txt.c yview] 1]\n\
      grow_canvas\n\
  }\n\
}\n\
\n\
proc move_up_out_of_window {id lnum} {\n\
  global xpos ypos fh fw\n\
  set top [.m.l.txt.c canvasy 0]\n\
  if {[expr $fh * ($lnum + $ypos($id) + 0)] < $top } {\n\
      set ymax [lindex [.m.l.txt.c bbox all] 3]\n\
      if {$ymax == \"\"} { set ymax 0.0 }\n\
      set top [expr ([.m.l.txt.c canvasy 0]-$fh) / $ymax]\n\
      if {$top < 0} { set top 0 }\n\
      .m.l.txt.c yview moveto $top\n\
      .m.l.txt.sb set [lindex [.m.l.txt.c yview] 0] [lindex [.m.l.txt.c yview] 1]\n\
      grow_canvas\n\
  }\n\
}\n\
\n\
proc insert_char {x y A} {\n\
  global cur_block\n\
  global xpos ypos\n\
  global xp yp\n\
  global curline curlnum cur_col\n\
  global fh fw\n\
  set lock [ui_get_my_lock_status $cur_block]\n\
  if { $lock == \"LOCKED\" } { \n\
      display_lock $cur_block\n\
      return \n\
  }\n\
  catch {set xcpos [.m.l.txt.c index $cur_block xinsert]}\n\
  if {[expr $xcpos + $xpos($cur_block)] == 89} {\n\
      insert_cr\n\
  }\n\
  .m.l.txt.c insert $cur_block insert $A\n\
  set pos [.m.l.txt.c index $cur_block insert]\n\
  set xcpos [.m.l.txt.c index $cur_block xinsert]\n\
  set ycpos [.m.l.txt.c index $cur_block yinsert]\n\
  set txt [lindex [.m.l.txt.c itemconfigure $cur_block -text] 4]\n\
  set lstart [.m.l.txt.c index $cur_block linestart]\n\
  set lend [.m.l.txt.c index $cur_block lineend]\n\
  set curline [string range $txt $lstart $lend]\n\
  catch {ui_set_line $cur_block $ycpos $curline}\n\
  ui_send_shared_pointer [expr $fw * ($xpos($cur_block) + $xcpos)] \\\n\
      [expr $fh * ($ypos($cur_block) + $ycpos)]\\\n\
	  $cur_col pen\n\
  set_info_display\n\
}\n\
\n\
proc get_line {txt pos} {\n\
  global curline\n\
  global curlnum\n\
  set lines [split $txt \"\\n\"]\n\
#  puts $lines\n\
  set offset 0\n\
  set lnum 0\n\
  set curline \"\"\n\
  set curlnum 0\n\
  foreach line $lines {\n\
      if {[expr $offset + [string length $line]] >= $pos} {\n\
	  set curline $line\n\
	  set curlnum $lnum\n\
	  break\n\
      }\n\
      incr lnum\n\
      set offset [expr $offset + [string length $line] + 1]\n\
  }\n\
}\n\
\n\
proc delete_char {} {\n\
  global cur_block\n\
  global xpos ypos\n\
  global xp yp\n\
  global curline curlnum fw fh cur_col\n\
  \n\
  if {[ui_get_my_lock_status $cur_block] == \"LOCKED\" } { \n\
      display_lock $cur_block\n\
      return \n\
  }\n\
  set pos [.m.l.txt.c index $cur_block insert]\n\
  set txt [lindex [.m.l.txt.c itemconfigure $cur_block -text] 4]\n\
  set xcpos [.m.l.txt.c index $cur_block xinsert]\n\
  set ycpos [.m.l.txt.c index $cur_block yinsert]\n\
  set lstart [.m.l.txt.c index $cur_block linestart]\n\
  set lend [.m.l.txt.c index $cur_block lineend]\n\
  set curline [string range $txt $lstart $lend]\n\
\n\
\n\
  if { [string index $txt [expr $pos-1]]==\"\\n\"} {\n\
      ui_delete_line $cur_block $ycpos\n\
  }\n\
 \n\
  textBs .m.l.txt.c $cur_block\n\
  set pos [.m.l.txt.c index $cur_block insert]\n\
  set txt [lindex [.m.l.txt.c itemconfigure $cur_block -text] 4]\n\
  set xcpos [.m.l.txt.c index $cur_block xinsert]\n\
  set ycpos [.m.l.txt.c index $cur_block yinsert]\n\
  set lstart [.m.l.txt.c index $cur_block linestart]\n\
  set lend [.m.l.txt.c index $cur_block lineend]\n\
  set curline [string range $txt $lstart $lend]\n\
  ui_set_line $cur_block $ycpos $curline\n\
  ui_send_shared_pointer [expr $fw * ($xpos($cur_block) + $xcpos)] \\\n\
      [expr $fh * ($ypos($cur_block) + $ycpos)]\\\n\
          $cur_col pen\n\
  set_info_display\n\
}\n\
\n\
proc textBs {w b} {\n\
    set char [expr {[$w index $b insert] - 1}]\n\
    if {$char >= 0} {$w dchar $b $char}\n\
}\n\
\n\
proc set_block_posn {blockid x y} {\n\
    global fw fh\n\
    global xpos ypos\n\
    .m.l.txt.c coords $blockid \\\n\
	[expr $fw * $x] [expr $fh * $y]\n\
    set xpos($blockid) $x\n\
    set ypos($blockid) $y\n\
    grow_canvas\n\
}\n\
\n\
proc set_block_colour {id coli} {\n\
    global col\n\
    global cur_block\n\
    .m.l.txt.c  itemconfigure $id -fill $col($coli)\n\
    if {$id == $cur_block} {set_info_display}\n\
}\n\
\n\
proc set_block_font {id fonti} {\n\
    global font\n\
    .m.l.txt.c itemconfigure $id -font $font($fonti)\n\
}\n\
\n\
proc set_block {id str x y fonti coli} {\n\
    global exists\n\
    global cur_block\n\
    set code [catch {set tmp $exists($id)}]\n\
    if {$code==1} {\n\
        set exists($id) 1\n\
	create_block_item $id $x $y $fonti $coli\n\
    }\n\
    .m.l.txt.c itemconfigure $id -text $str\n\
    if {$cur_block==$id} { set_info_display }\n\
    grow_canvas\n\
}\n\
\n\
proc tcol {tag col} {\n\
  .m.l.txt.t tag configure $tag -foreground $col\n\
}\n\
\n\
proc get_cur_tag {} {\n\
  global cur_block\n\
#  puts \"cur block now $cur_block\"\n\
}\n\
\n\
set maxid 1\n\
set old_block 0\n\
proc new_block {x y} {\n\
  global cur_block\n\
  global xpos ypos\n\
  global col cur_col\n\
  global font cur_font\n\
  global maxid\n\
  global exists\n\
  global fw fh\n\
  global old_block\n\
  if {$old_block==1} {\n\
#    puts oldblock\n\
    set_info_display\n\
    flash_block $cur_block\n\
    set old_block 0\n\
    return\n\
  }\n\
  set y [expr $y / $fh]\n\
  set x [expr $x / $fw]\n\
  set cur_block [ui_generate_id]\n\
  set cur_line 0\n\
  set xpos($cur_block) $x\n\
  set ypos($cur_block) $y\n\
#don't know why I need this catch when I'm returning TCK_OK\n\
  catch { ui_new_block $cur_block $xpos($cur_block) $ypos($cur_block) \\\n\
      $cur_col $cur_font }\n\
  set exists($cur_block) 1\n\
  create_block_item $cur_block $x $y $cur_font $cur_col\n\
  .m.l.txt.c icursor $cur_block @$x,$y\n\
  .m.l.txt.c focus $cur_block\n\
  focus .m.l.txt.c\n\
  set_info_display\n\
}\n\
\n\
proc set_cur_block {w x y} {\n\
    global cur_block\n\
    global old_block\n\
    set old_block 1\n\
#    puts \"cur_block: $w\"\n\
    set cur_block $w\n\
    .m.l.txt.c icursor $w @$x,$y\n\
    .m.l.txt.c focus $w\n\
    focus .m.l.txt.c\n\
}\n\
\n\
set flash_col none\n\
proc flash_block {id} {\n\
    global flash_col\n\
#another global needed to make this re-entrant\n\
    if {$flash_col == \"none\"} {\n\
	set flash_col [lindex [.m.l.txt.c itemconfigure $id -fill] 4]\n\
    }\n\
    .m.l.txt.c itemconfigure $id -fill gray80\n\
    after 150 \".m.l.txt.c itemconfigure $id -fill $flash_col; \\\n\
               set flash_col \\\"none\\\"\"\n\
}\n\
\n\
pack append .m.l.txt \\\n\
    .m.l.txt.sb {right filly} \\\n\
    .m.l.txt.c {left fill expand}\n\
\n\
\n\
if {$part_vis==1} {\n\
    pack .m.l.ss -side right -fill both \n\
}\n\
pack .m.l.txt -side left -fill both -expand true\n\
\n\
pack append .m \\\n\
     .m.cp {top fillx} \\\n\
     .m.in {top fillx} \\\n\
     .m.l {top fill expand}\n\
\n\
pack append . .m {top fill expand}\n\
wm minsize . 600 200\n\
proc load_text {mode} {\n\
  global load_mode\n\
  set load_mode $mode\n\
  catch {destroy .load}\n\
  toplevel .load\n\
  wm title .load \"nt: load file\"\n\
  lognewwindow .load\n\
  if {[string compare $mode \"plain\"]==0} {\n\
      message .load.msg  -aspect 300 -text \"Select a plain text file to load:\"\n\
  } else {\n\
      message .load.msg  -aspect 300 -text \"Select an nt structured file to load:\"\n\
  }\n\
  frame .load.f\n\
  listbox .load.f.lb -width 40 -height 10 -relief sunken -yscroll \".load.f.sb set\"\n\
  scrollbar .load.f.sb -command \".load.f.lb yview\" \\\n\
      -background [option get . background Mtool] \\\n\
      -troughcolor [option get . scrollbarBackground Mtool]\n\
  pack .load.f.lb -side left\n\
  pack .load.f.sb -side right -fill y\n\
  .load.f.lb insert end \"..\"\n\
  foreach i [glob *] {\n\
    .load.f.lb insert end $i\n\
  }\n\
  label .load.l -text \"File:\"\n\
  entry .load.entry -width 40 -relief sunken\n\
  bind .load.entry <Return> {load_text_file $load_mode [.load.entry get]}\n\
  .load.entry insert 0 [pwd]\n\
  frame .load.bb -relief sunken\n\
  button .load.bb.load -text \"Load\" -command \\\n\
    {load_text_file $load_mode [.load.entry get]}\n\
  button .load.bb.cancel -text \"Cancel\" -command \"destroy .load\"\n\
  bind .load.f.lb <1> { %W selection set [%W nearest %y];\\\n\
      .load.entry delete 0 end;\\\n\
      .load.entry insert 0 \"[pwd]/[%W get [%W nearest %y]]\"}\n\
\n\
  bind .load.f.lb <Double-Button-1> {load_text_file $load_mode [lindex [selection get] 0];break}\n\
  pack append .load.bb \\\n\
      .load.bb.load {left expand fillx} \\\n\
      .load.bb.cancel {left expand fillx}\n\
  pack append .load \\\n\
      .load.msg {top fillx expand} \\\n\
      .load.f  {top fill expand} \\\n\
      .load.l {top fillx expand} \\\n\
      .load.entry {top fillx expand} \\\n\
      .load.bb {top fillx expand}\n\
}\n\
\n\
proc load_text_file {mode file} {\n\
  global cur_block\n\
  global cur_line\n\
  global cur_col\n\
  global cur_font\n\
  global xpos ypos\n\
  global font\n\
  global exists\n\
  if {[file isdirectory $file]} {\n\
    .load.f.lb delete 0 end\n\
    cd $file\n\
    .load.f.lb insert end \"..\"\n\
    foreach i [glob *] {\n\
      .load.f.lb insert end $i\n\
    }\n\
    .load.entry delete 0 end\n\
    .load.entry insert 0 [pwd]\n\
  } elseif {[file readable $file]} {\n\
      if {$mode==\"plain\"} {\n\
	  set cur_block [ui_generate_id]\n\
	  set ypos($cur_block) 0\n\
	  set xpos($cur_block) 0\n\
	  ui_new_block $cur_block 0 0 $cur_col $cur_font\n\
	  set exists($cur_block) 1\n\
	  create_block_item $cur_block 0 0 $cur_font $cur_col\n\
	  ui_load_text_file $file\n\
	  grow_canvas\n\
	  set_col $cur_col\n\
	  set_font $cur_font\n\
	  catch {destroy .load}\n\
	  update\n\
	  set_info_display\n\
      } else {\n\
	  ui_load_struct_file $file\n\
	  catch {destroy .load}\n\
      }\n\
  } else {\n\
      error \"File not readable\"\n\
  }\n\
}\n\
\n\
proc save_text {mode} {\n\
  global save_mode\n\
  catch {destroy .save}\n\
  toplevel .save\n\
  wm title .save \"nt: save file\"\n\
  lognewwindow .save\n\
  set save_mode $mode\n\
  if {[string compare $mode \"plain\"]==0} {\n\
      message .save.msg  -aspect 300 -text \"Select a plain text file to save:\"\n\
  } else {\n\
      message .save.msg  -aspect 300 -text \"Select a structured text file to save:\"\n\
  }\n\
  frame .save.f\n\
  listbox .save.f.lb -width 40 -height 10 -relief sunken -yscroll \".save.f.sb set\"\n\
  scrollbar .save.f.sb -command \".save.f.lb yview\" \\\n\
      -background [option get . background Mtool] \\\n\
      -troughcolor [option get . scrollbarBackground Mtool]\n\
  pack .save.f.lb -side left\n\
  pack .save.f.sb -side right -fill y\n\
  .save.f.lb insert end \"..\"\n\
  foreach i [glob *] {\n\
    .save.f.lb insert end $i\n\
  }\n\
  label .save.l -text \"File:\"\n\
  entry .save.entry -width 40 -relief sunken\n\
  bind .save.entry <Return> {save_text_file $save_pptnts $save_mode [.save.entry get]}\n\
  .save.entry insert 0 [pwd]\n\
  global save_pptnts\n\
  set save_pptnts FALSE\n\
  if {[string compare $mode \"plain\"]==0} {\n\
      frame .save.f2 -borderwidth 0 -relief flat\n\
      checkbutton .save.f2.b -text \"Save Participants\" -variable save_pptnts\\\n\
	  -onvalue TRUE -offvalue FALSE -borderwidth 1\n\
      pack .save.f2.b -side left -fill x -expand true\n\
  }\n\
\n\
  frame .save.bb -relief sunken\n\
  button .save.bb.save -text \"Save\" -command \\\n\
    {save_text_file $save_pptnts $save_mode [.save.entry get]}\n\
  button .save.bb.cancel -text \"Cancel\" -command \"destroy .save\"\n\
  bind .save.f.lb <1> {catch {%W selection set [%W nearest %y];\\\n\
      .save.entry delete 0 end;\\\n\
	  .save.entry insert 0 \"[pwd]/[%W get [%W nearest %y]]\"} }\n\
\n\
  bind .save.f.lb <Double-Button-1> {save_text_file $save_pptnts $save_mode [lindex [selection get] 0];break}\n\
  pack append .save.bb \\\n\
      .save.bb.save {left expand fillx} \\\n\
      .save.bb.cancel {left expand fillx}\n\
  pack append .save \\\n\
      .save.msg {top fillx expand} \\\n\
      .save.f {top fill expand}\n\
  pack .save.l -side top -fill x -expand true\n\
  pack .save.entry -side top -fill x -expand true\n\
  if {[string compare $mode \"plain\"]==0} {\n\
      pack .save.f2 -side top -fill x -expand true\n\
  }\n\
  pack .save.bb -side top -fill x -expand true\n\
  \n\
}\n\
\n\
\n\
proc save_text_file {save_pptns mode file} {\n\
  global cur_block\n\
  global cur_line\n\
  global cur_col\n\
  global cur_font\n\
  global xpos ypos\n\
  global font\n\
  global exists\n\
  if {[file isdirectory $file]} {\n\
    .save.f.lb delete 0 end\n\
    cd $file\n\
    .save.f.lb insert end \"..\"\n\
    foreach i [glob *] {\n\
      .save.f.lb insert end $i\n\
    }\n\
    .save.entry delete 0 end\n\
    .save.entry insert 0 [pwd]\n\
  } else {\n\
      if {$mode==\"plain\"} {\n\
	  ui_save_text_file $save_pptns $file\n\
      } else {\n\
	  ui_save_struct_file $file\n\
      }\n\
      catch {destroy .save}\n\
      update\n\
      set_info_display\n\
  }\n\
}\n\
\n\
proc quit {} {\n\
    ui_quit\n\
    destroy .\n\
}\n\
proc add_participant {c} {\n\
    global c_str col\n\
#    puts \"add: $c_str, $c\"\n\
    set pos [.m.l.ss.f.lb index end-1c]\n\
#    .m.l.ss.f.lb configure -state normal\n\
    .m.l.ss.f.lb insert end \"$c_str\\n\"\n\
    .m.l.ss.f.lb tag add \"l$c_str\" $pos end-1c\n\
    .m.l.ss.f.lb tag configure \"l$c_str\" -foreground $col($c)\n\
    .m.l.ss.f.lb tag bind \"l$c_str\" <1> \"show_participant_details %y\"\n\
#    .m.l.ss.f.lb configure -state disabled\n\
}\n\
\n\
proc show_participant_details {y} {\n\
    global col\n\
    set pos [.m.l.ss.f.lb index @0,$y]\n\
    set pos [lindex [split $pos \".\"] 0]\n\
    set details [get_participant_by_number [expr $pos -1]]\n\
    catch {destroy .pt$pos}\n\
    toplevel .pt$pos \n\
    wm title .pt$pos \"Participant Details\"\n\
    frame .pt$pos.f -borderwidth 2 -relief groove\n\
    pack .pt$pos.f -side top -fill both\n\
    label .pt$pos.f.l1 -text [lindex $details 0]\n\
    pack .pt$pos.f.l1 -side top -anchor nw\n\
    label .pt$pos.f.l2 -text \"NTE version: [lindex $details 1]\"\n\
    pack .pt$pos.f.l2 -side top -anchor nw\n\
    label .pt$pos.f.l3 -text \"Platform: [lindex $details 2]\"\n\
    pack .pt$pos.f.l3 -side top -anchor nw\n\
    frame .pt$pos.f.f -borderwidth 0\n\
    pack .pt$pos.f.f -side top -fill x -expand true\n\
    label .pt$pos.f.f.l1 -text \"Current colour:\"\n\
    pack .pt$pos.f.f.l1 -side left\n\
    label .pt$pos.f.f.l2 -text \"        \" -background $col([lindex $details 3])\n\
    pack .pt$pos.f.f.l2 -side right -fill x -expand true\n\
    button .pt$pos.f.dismiss -text \"Dismiss\" -command \"destroy .pt$pos\"\n\
    pack .pt$pos.f.dismiss -side top -fill x -expand true\n\
}\n\
proc rm_participant {n} {\n\
#    .m.l.ss.f.lb configure -state normal\n\
    .m.l.ss.f.lb delete [expr $n + 1].0 \"[expr $n + 2].0\"\n\
#    .m.l.ss.f.lb configure -state disabled\n\
}\n\
\n\
#proc clear_participants {} {\n\
#    .m.l.ss.f.lb delete 2.0 end\n\
#}\n\
\n\
proc uncolour_participant {n c} {\n\
    global col\n\
#    puts \"uncolour $n $c\"\n\
#    .m.l.ss.f.lb configure -state normal\n\
#    .m.l.ss.f.lb tag remove \"l$c\" [expr $n + 1].0 \"[expr $n + 1].0 lineend\"\n\
#    .m.l.ss.f.lb configure -state disabled\n\
}\n\
\n\
proc colour_participant {n c} {\n\
    global col\n\
#    puts \"colour $n $c\"\n\
#    .m.l.ss.f.lb configure -state normal\n\
#    .m.l.ss.f.lb tag add \"l$c\" [expr $n + 1].0 \"[expr $n + 1].0 lineend\"\n\
    set tags [.m.l.ss.f.lb tag names [expr $n + 1].0]\n\
    .m.l.ss.f.lb tag configure [lindex $tags 0] -foreground $col($c)\n\
#    .m.l.ss.f.lb configure -state disabled\n\
#    puts $col($c)\n\
}\n\
\n\
proc activate_participant {n} {\n\
#    .m.l.ss.f.lb configure -state normal\n\
    .m.l.ss.f.lb tag remove inactive [expr $n + 2].0 \"[expr $n + 1].0 lineend\"\n\
#    .m.l.ss.f.lb configure -state disabled\n\
}\n\
\n\
proc deactivate_participant {n} {\n\
#    .m.l.ss.f.lb configure -state normal\n\
    .m.l.ss.f.lb tag add inactive [expr $n + 1].0 \"[expr $n + 1].0 lineend\"\n\
#    .m.l.ss.f.lb configure -state disabled\n\
}\n\
\n\
proc create_my_shared_pointer {x y} {\n\
    global cur_col\n\
    create_shared_pointer myid me $x $y $cur_col arrow\n\
}\n\
proc create_shared_pointer {id name x y pcol style} {\n\
    global pxpos pypos\n\
    global col font fw fh\n\
    indicate_activity $id $y $pcol\n\
    if {$style==\"arrow\"} {\n\
	.m.l.txt.c addtag $id withtag \\\n\
	    [.m.l.txt.c create \\\n\
	     polygon 0 0 10 0 6 4 35 25 25 25 25 35 4 6 0 10 0 0 \\\n\
		 -fill $col($pcol)]\n\
	.m.l.txt.c addtag $id.bg withtag \\\n\
            [.m.l.txt.c create \\\n\
	     rectangle [expr $x + 25] [expr $y + 25] \\\n\
		 [expr $x + 27 + [expr [string length $name] * $fw]] \\\n\
		 [expr $y + 25 + $fh ] -fill white -outline $col($pcol) ]\n\
	.m.l.txt.c addtag $id.label withtag \\\n\
	    [.m.l.txt.c create \\\n\
	     text [expr $x + 26] [expr $y + 25] -fill $col($pcol) -anchor nw \\\n\
		 -text $name -font $font(2)]\n\
    }\n\
    if {$style==\"oldhand\"} {\n\
        .m.l.txt.c addtag $id withtag \\\n\
            [.m.l.txt.c create \\\n\
             polygon \\\n\
		 0 -10  20 -10  20 0  15 0  15 -3  -3 -3  -3 15  0 15 \\\n\
		 0 20  -10 20  -10 0  -20 -10 -10 -20 \\\n\
                 -fill $col($pcol)]\n\
	.m.l.txt.c addtag $id.bg withtag \\\n\
            [.m.l.txt.c create \\\n\
	     rectangle [expr $x - 2] [expr $y - 23] \\\n\
		 [expr $x + [expr [string length $name] * $fw]] \\\n\
		 [expr $y - 23 + $fh] -fill white -outline \"\"]\n\
        .m.l.txt.c addtag $id.label withtag \\\n\
            [.m.l.txt.c create \\\n\
             text [expr $x - 2] [expr $y - 23] -fill $col($pcol) -anchor nw \\\n\
                 -text $name  -font $font(2)]\n\
    }\n\
    if {$style==\"hand\"} {\n\
        .m.l.txt.c addtag $id withtag \\\n\
            [.m.l.txt.c create \\\n\
            bitmap 0 0 -foreground $col($pcol) -anchor ne \\\n\
                 -bitmap \"digger\" ]\n\
	.m.l.txt.c addtag $id.bg withtag \\\n\
            [.m.l.txt.c create \\\n\
	     rectangle [expr $x - 42] [expr $y - 15] \\\n\
		 [expr $x + [expr [string length $name] * $fw] - 40] \\\n\
		 [expr $y - 15 + $fh] -fill white -outline $col($pcol)]\n\
        .m.l.txt.c addtag $id.label withtag \\\n\
            [.m.l.txt.c create \\\n\
             text [expr $x - 42] [expr $y - 15] -fill $col($pcol) -anchor nw \\\n\
                 -text $name  -font $font(2)]\n\
    }\n\
    if {$style==\"lock\"} {\n\
        .m.l.txt.c addtag $id withtag \\\n\
            [.m.l.txt.c create \\\n\
	     bitmap 0 0 -foreground $col($pcol) -anchor nw \\\n\
                 -bitmap \"locked\" ]\n\
	.m.l.txt.c addtag $id.bg withtag \\\n\
            [.m.l.txt.c create \\\n\
	     rectangle [expr $x + 20] $y \\\n\
		 [expr $x + 22 + [expr [string length $name] * $fw]] \\\n\
		 [expr $y + 1 + $fh ] -fill white -outline $col($pcol) ]\n\
        .m.l.txt.c addtag $id.label withtag \\\n\
            [.m.l.txt.c create \\\n\
             text [expr $x +20] $y -fill $col($pcol) -anchor nw \\\n\
                 -text $name  -font $font(2)]\n\
    }\n\
    if {$style==\"eraser\"} {\n\
        .m.l.txt.c addtag $id withtag \\\n\
            [.m.l.txt.c create \\\n\
	     bitmap 0 0 -foreground $col($pcol) -anchor nw \\\n\
                 -bitmap \"eraser\" ]\n\
	.m.l.txt.c addtag $id.bg withtag \\\n\
            [.m.l.txt.c create \\\n\
	     rectangle [expr $x + 32] $y \\\n\
		 [expr $x + 34 + [expr [string length $name] * $fw]] \\\n\
		 [expr $y + 1 + $fh ] -fill white -outline $col($pcol) ]\n\
        .m.l.txt.c addtag $id.label withtag \\\n\
            [.m.l.txt.c create \\\n\
             text [expr $x +30] $y -fill $col($pcol) -anchor nw \\\n\
                 -text $name  -font $font(2)]\n\
    }\n\
    if {$style==\"pen\"} {\n\
        .m.l.txt.c addtag $id withtag \\\n\
            [.m.l.txt.c create \\\n\
	     bitmap 0 0 -foreground $col($pcol) -anchor s \\\n\
                 -bitmap \"pen\" ]\n\
	.m.l.txt.c addtag $id.bg withtag \\\n\
            [.m.l.txt.c create \\\n\
	     rectangle [expr $x + 8] [expr $y - 30]\\\n\
		 [expr $x + 10 + [expr [string length $name] * $fw]] \\\n\
		 [expr $y -30 + $fh ] -fill white -outline $col($pcol) ]\n\
        .m.l.txt.c addtag $id.label withtag \\\n\
            [.m.l.txt.c create \\\n\
             text [expr $x +9] [expr $y - 30] -fill $col($pcol) -anchor nw \\\n\
                 -text $name  -font $font(2)]\n\
    }\n\
    .m.l.txt.c move $id $x $y\n\
    set pxpos($id) $x\n\
    set pypos($id) $y\n\
}\n\
\n\
proc move_my_shared_pointer {x y} {\n\
    global cur_col\n\
    move_shared_pointer myid me $x $y $cur_col arrow\n\
    ui_send_shared_pointer $x $y $cur_col arrow\n\
}\n\
\n\
proc move_shared_pointer {id name x y pcol style} {\n\
    global pxpos pypos\n\
    if {($x==65535)&&($y==65535)} {\n\
	catch {\n\
	    delete_shared_pointer $id\n\
	}\n\
	return\n\
    }\n\
    \n\
    indicate_activity $id $y $pcol\n\
    if { [catch {\n\
	set nx [expr $x - $pxpos($id)]\n\
	set ny [expr $y - $pypos($id)]\n\
	.m.l.txt.c move $id.label $nx $ny\n\
	.m.l.txt.c move $id $nx $ny\n\
	.m.l.txt.c move $id.bg $nx $ny\n\
	set pxpos($id) $x\n\
	set pypos($id) $y\n\
    }] == 1} {\n\
	create_shared_pointer $id $name $x $y $pcol $style\n\
	after 5000 \"delete_shared_pointer $id\"\n\
    }\n\
}\n\
\n\
proc delete_my_shared_pointer {} {\n\
    delete_shared_pointer myid\n\
    ui_send_shared_pointer 65535 65535 0 arrow\n\
}\n\
\n\
proc delete_shared_pointer {id} {\n\
    global pxpos pypos\n\
    catch {\n\
	.m.l.txt.c delete $id\n\
	.m.l.txt.c delete $id.bg\n\
	.m.l.txt.c delete $id.label\n\
	unset pxpos($id)\n\
	unset pypos($id)\n\
    }\n\
\n\
}\n\
proc display_lock {blockid} {\n\
    global xpos ypos\n\
    global fw fh\n\
    flash_block $blockid\n\
    delete_shared_pointer lockid\n\
    create_shared_pointer lockid \"locked\" \\\n\
	[expr $xpos($blockid) * $fw] [expr $ypos($blockid) * $fh] \\\n\
	7 lock\n\
    after 1000 delete_shared_pointer lockid\n\
}\n\
\n\
proc create_block_item {id x y fonti coli} {\n\
global xpos ypos fw fh font col tcl_platform\n\
	.m.l.txt.c addtag $id withtag \\\n\
	    [.m.l.txt.c create text [expr $x * $fw] [expr $y * $fh] -anchor nw\\\n\
	     -fill $col($coli) -font $font($fonti)]\n\
        .m.l.txt.c bind $id <1> \\\n\
            \"set_cur_block $id %x \\[expr %y + \\[set canvypos\\]\\]\"\n\
        if {$tcl_platform(platform) == \"unix\"} {\n\
	    .m.l.txt.c bind $id <2> \\\n\
		\"startmoveblock $id %x \\[expr %y + \\[set canvypos\\]\\]\"\n\
	} else {\n\
	    .m.l.txt.c bind $id <Shift-ButtonPress-1> \\\n\
		\"startmoveblock $id %x \\[expr %y + \\[set canvypos\\]\\]\"\n\
	}\n\
	set xpos($id) $x\n\
	set ypos($id) $y\n\
}\n\
\n\
proc set_key {enc} {\n\
    if {$enc==1} {\n\
	global encrypt\n\
	set encrypt 0\n\
	catch {destroy .key}\n\
	toplevel .key\n\
	wm title .key \"Set Encryption Key\"\n\
	message .key.m -text \"Enter the pass phrase for this session:\" -aspect 400\n\
	pack .key.m -side top\n\
\n\
	password .key.key -width 30 -relief sunken -borderwidth 1 \\\n\
	    -variable tmppass\n\
	pack .key.key -side top -fill x -expand true\n\
	label .key.msg -relief raised -borderwidth 1\n\
	pack .key.msg -side top -fill x -expand true\n\
	frame .key.f -borderwidth 0\n\
	button .key.f.set -text \"Enable Encryption\" \\\n\
	    -command {enable_encryption $tmppass} \\\n\
	    -relief raised -borderwidth 1\n\
	bind .key.key <Return> {enable_encryption $tmppass}\n\
	button .key.f.cancel -text \"Cancel\" -command \"destroy .key\" \\\n\
	    -borderwidth 1\n\
	pack .key.f -side top -fill x -expand true\n\
	pack .key.f.set -side left -fill x -expand true\n\
	pack .key.f.cancel -side left -fill x -expand true\n\
    } else {\n\
	reset_participants\n\
	set_encryption_key \"\"\n\
    }\n\
}\n\
\n\
proc enable_encryption {key} {\n\
    if {[string length $key]<6} {\n\
	bell\n\
	.key.msg configure -text \"Key must be at least 8 chars\"\n\
	after 3000 .key.msg configure -text \\\"\\\"\n\
    } else {\n\
	set_encryption_key $key\n\
	global encrypt\n\
	set encrypt 1\n\
	reset_participants\n\
	catch {destroy .key}\n\
    }\n\
}\n\
grow_canvas\n\
";
